"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Koa = require("koa");
const validator = require("../index");
const app = new Koa();
app.use(validator());
app.use((ctx) => __awaiter(void 0, void 0, void 0, function* () {
    const { bodyValidator, paramsValidator, queryValidator } = ctx.validator;
    const requestObj = ctx.validator.context;
    requestObj.accepts();
    bodyValidator.property("prop1").optional().isArray();
    paramsValidator.property("prop2").isNotEmpty().withMessage("test message");
    queryValidator.property("prop3").optional().isBoolean();
    const hasErrors = yield ctx.validator.hasErrors();
    if (hasErrors) {
        const errors = yield ctx.validator.getErrors();
        errors.forEach((error) => {
            console.log(`${error.value}, ${error.errorMessage}, ${error.path}`);
        });
    }
}));
